#########################################################################
############### CORRECTION TP1 : INITIATION AU LOGICIEL R ###############
#########################################################################

# Exercice 1 : Manipulations simples

1:3^2
(1:5)*2
x<-2
2x<-2*x
x<-1
x< -1
var<-3
Var*2
TRUE+T+FALSE*F+T*FALSE+F

# Exercice 2 : Vecteurs

#Q1

vec1<-rep(1:5,3)
vec2<-rep(1:5,each=3)
vec3<-rep(1:4,times=(2:5))

#Q2

vec4<-paste("A",1:10,")",sep="")
vec4

#Q3

pos.q=which(letters=="q")
vec5<-paste(letters[1:pos.q],1:pos.q,sep="")
vec5

#Q4

x=c(5,4,8,NA,0,-9,NA)
x[is.na(x)]=0

#Q5

y=runif(15,-1,1)
y[y<0]=-y[y<0]

#Q6

(1:length(x))[x==min(x)]

# Exercice 3 : Quelques calculs

#Q1

sum((10:100)^3+4*(10:100)^2)

#Q2

x=sample(0:99,100,replace=TRUE)
y=sample(0:99,100,replace=TRUE)
#a)
y[2:length(y)]-x[1:(length(x)-1)]
#b)
sin(y[1:(length(y)-1)])/cos(x[2:length(x)])
#c)
x[1:(length(x)-2)]+2*x[2:(length(x)-1)]-x[3:length(x)]
#d)
sum(exp(-(x[2:length(x)]))/(x[1:(length(x)-1)]+10))

# Exercice 4 : Valeurs manquantes

#Q1

set.seed(7)
vec1<-runif(100,0,7)
mean(vec1)
# Calcul de la variance de trois faons diffrentes
mean(vec1^2)-(mean(vec1))^2
mean((vec1-mean(vec1))^2)
99/100*var(vec1)

#Q2

vec2=vec1
set.seed(8)
ind<-sample(1:100,10)
vec2[ind]=NA

#Q3

mean(vec2)
99/100*var(vec2)
mean(vec2, na.rm=TRUE)
99/100*var(vec2, na.rm=TRUE)

#Q4

vec3<-vec2[-ind]
mean(vec3)
99/100*var(vec3)

#Q5

vec4=vec2
vec4[ind]=mean(vec3)

#Q6

vec5<- vec2
vec5[ind]=sample(vec3,10)

# Exercice 5 : Cration et inversion de matrice, slection dans une matrice

#Q1

mat<-matrix(c(1,0,3,4,5,5,0,4,5,6,3,4,0,1,3,2),ncol=4)
rownames(mat)=paste("ligne",1:4,sep="-")
colnames(mat)=paste("colonne",1:4)

#Q2

vec<-diag(mat)
vec

#Q3

mat1=mat[1:2,]
mat1

#Q4

mat2<-mat[,3:4]
mat2

#Q5

mat3=mat[,-3]
mat3

#Q6

det(mat)
solve(mat)

#Q7

apply(mat,1,sum)

#Q8

apply(mat,2,max)

#Q9

mat4=mat[,apply(mat<6,2,FUN=all)]
mat4

#Q10

mat5=mat[apply(!(mat==0),1,all),]
mat5

# Exercice 6 : Calcul matriciel - Rgression

#Q1

data(mtcars)
y=mtcars$mpg

#Q2

X=cbind(rep(1,length(y)),mtcars$hp,mtcars$wt)

#Q3
# Transposition de X
t(X)

#Q4
t(X)%*%X
crossprod(X,X)

#Q5

solve(t(X)%*%X)

#Q6
t(X)%*%y

#Q7 Estimation des paramtres

solve(t(X)%*%X)%*%t(X)%*%y

# Vrification 

lm(mpg~1+hp+wt, data=mtcars)

# Exercice 7 : Data-frame

#Q1

library(MASS)

#Q2

data(iris)
head(iris)
iris2=iris[iris[,5]=="versicolor",]
iris2

#Q3

iris2[order(iris2[,1],decreasing=TRUE),]

#Q4

is.vector(iris$Species)
is.factor(iris$Species)
is.numeric(iris$Species)

#Q5

by(iris$Sepal.Width, iris$Species, mean)

# Exercice 8 : Utilisation des fonctions apply, lapply

#Q1
#a)
library(lattice)
data(ethanol)
summary(ethanol)
#b)
apply(ethanol,2,quantile)
#c)
apply(ethanol,2,quantile,probs=seq(0,1, by=0.1))

#Q2
#a)
library(MASS)
data(Aids2)
summary(Aids2)
#b)
indice<-!unlist(lapply(Aids2,is.numeric))
#c)
Aids2.qual=Aids2[,indice]
#d)
lapply(Aids2.qual,levels)

# Exercice 9 : Importation de donnes

#Q1

test1=read.table("test1.csv",header=TRUE, sep=";",dec=",")
summary(test1)
test2=read.table("test2.csv", sep=";",dec=".",header=TRUE, na.strings="")
summary(test2)
test3=read.table("test3.csv", sep=";",dec=".",header=TRUE,na.strings=".")
summary(test3)

#Q2
#a)
etat1=read.table("etat1.csv",header=TRUE,sep=";")
# etat1=read.csv2("etat1.csv", header=TRUE) # sep=","
head(etat1)
etat2=read.table("etat2.csv",header=TRUE,sep=",",dec=".")
# etat2=read.csv("etat2.csv", header=TRUE, dec=".") # sep=";"
summary(etat2)
etat3=read.table("etat3.csv",header=TRUE,row.names=1)
head(etat3)
#b)
etat13=merge(etat1,etat3,by="region")
etat123=merge(etat2,etat13,by="etat")
