#########################################################################
############### CORRECTION TP3 : INITIATION AU LOGICIEL R ###############
#########################################################################

# Exercice 1: Factorielle

facto<-function(n)
{
  if(n<0) stop("n doit tre un entier positif.") 
  if(floor(n)!=n) stop("n doit tre un entier positif.")
  if(n==0)
  {
    res=1
  } else
  {
    res=prod(1:n)
  }
  return(res)
}
facto(12)


# Exercice 2 : Simulation de lois usuelles

chideux<-function(ddl, nbtirage)
{
  M<-matrix(rnorm(ddl*nbtirage),nrow=nbtirage,ncol=ddl)
  M<-M^2
  return(apply(M,1,sum))
}

chideux(3,1000)

hist(chideux(3,1000),prob=TRUE)
curve(dchisq(x,3), add=TRUE,col=2)

student<-function(ddl, nbtirage)
{
  X=rnorm(nbtirage)
  Y=chideux(ddl,nbtirage)
  return(X/sqrt(Y/ddl))
}

student(7,1000)

hist(student(7,1000),prob=TRUE)
curve(dt(x,7), add=TRUE,col=2)

# Exercice 3 : Rgression linaire

#Q1 Moindres carrs

resume.reg<- function(x,y)
{
  aEst=cov(x,y)/(mean((x-mean(x))^2))
  bEst=mean(y)-aEst*mean(x)
  return(c(aEst,bEst,cor(x,y)))
}

affiche.reg<-function(x,y)
{
  aEst<-cov(x,y)/(mean((x-mean(x))^2))
  bEst<-mean(y)-aEst*mean(x)
  plot(x,y)
  abline(a=bEst, b=aEst)
}

attach(mtcars)
x=hp
y=mpg

resume.reg(x,y)
affiche.reg(x,y)
lm(mpg~hp, data=mtcars)
abline(lm(mpg~hp, data=mtcars))

#Q2

reg<-function(var_exp,Y)
{
  var_exp<-as.matrix(var_exp)
  Y<-as.matrix(Y)
  nbindiv<-nrow(var_exp)
  X<-cbind(rep(1,nbindiv),var_exp)
  betachap<-solve(t(X)%*%X)%*%t(X)%*%Y
  return(betachap)
}

x=cbind(hp,wt)
y=mpg

reg(x,y)

lm(mpg~hp+wt, data=mtcars)





